<template>
  <div class="content">
    <!-- <h4>Tabel Mata Kuliah KOTA</h4> -->
    <div style="margin-top: 50px;">
      <span style="font-size: 18px;"
        ><a href="#/dashboard/manajemen-dosen" style="color: grey"
          >Dosen Pengampu
        </a></span
      >
      <span style="font-size: 17px; padding: 0px 5px"> > </span>
      <span style="font-size: 18px">Tambah Dosen Pengampu</span>
    </div>
    <form ref="form" novalidate class="md-layout" @submit.prevent="onSubmit">
      <md-card
        class="md-layout-item md-size-95 md-small-size-100"
        style="padding: 0px 20px 30px 20px; margin-left: 30px"
      >
        <md-card-header>
          <div class="md-title">
            <h2 style="letter-spacing: 2px;color: green;margin-top:30px;">
              <strong>Input Dosen Pengampu</strong>
            </h2>
          </div>
        </md-card-header>

        <md-card-content>
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('nama')">
                <label for="nama">Nama Lengkap...</label>
                <md-input
                  name="nama"
                  id="nama"
                  v-model="dosenData.nama"
                  md-dense
                  :disabled="sending"
                >
                </md-input>
                <span class="md-error" v-if="!$v.dosenData.nama.required"
                  >Nama Lengkap Dosen is required</span
                >
              </md-field>
            </div>
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('nik')">
                <label for="nik">NIP...</label>
                <md-input
                  name="nik"
                  id="nik"
                  v-model="dosenData.nik"
                  md-dense
                  :disabled="sending"
                >
                </md-input>
                <span class="md-error" v-if="!$v.dosenData.nik.required"
                  >NIP Dosen is required</span
                >
              </md-field>
            </div>
          </div>
          <br />
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('jk')">
                <label for="jk">Jenis Kelamin...</label>
                <md-select
                  name="jk"
                  id="jk"
                  v-model="dosenData.jk"
                  md-dense
                  :disabled="sending"
                >
                  <md-option value="Laki-laki" style="width:100%; left: 10px;">
                    Laki-laki
                  </md-option>
                  <md-option value="Perempuan" style="width:100%; left: 10px;">
                    Perempuan
                  </md-option>
                </md-select>
                <span class="md-error" v-if="!$v.dosenData.jk.required"
                  >Jenis Kelamin is required</span
                >
              </md-field>
            </div>
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('prodi_id')">
                <label for="prodi_id">Program Studi...</label>
                <md-select
                  name="prodi_id"
                  id="prodi_id"
                  v-model="dosenData.prodi_id"
                  md-dense
                  :disabled="sending"
                >
                  <md-option
                    v-for="(prodi, key) in prodiList"
                    :key="key"
                    :value="prodi.id"
                    style="width:100%; left: 10px;"
                  >
                    {{ prodi.singkatan_prodi }} - {{ prodi.nama_prodi }}
                  </md-option>
                </md-select>
                <span class="md-error" v-if="!$v.dosenData.prodi_id.required"
                  >Prodi is required</span
                >
              </md-field>
            </div>
          </div>
          <br />
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('email')">
                <label for="email">Email...</label>
                <md-input
                  name="email"
                  id="email"
                  v-model="dosenData.email"
                  md-dense
                  :disabled="sending"
                >
                </md-input>
                <span class="md-error" v-if="!$v.dosenData.email.required"
                  >Email Dosen is required</span
                >
              </md-field>
            </div>
          </div>
        </md-card-content>

        <md-card-actions style="padding-top: 50px">
          <md-button
            type="submit"
            class="md-login md-success md-lg md-round"
            :disabled="sending"
            style="height: 50px; width: 140px"
            ><span
              style="color: white; font-size: 17px; text-transform: capitalize; bottom: 5px"
            >
              Submit
            </span>
          </md-button>
        </md-card-actions>

        <md-progress-bar md-mode="indeterminate" v-if="sending" />
      </md-card>

      <md-snackbar :md-active.sync="userSaved"
        >The user was saved with success!</md-snackbar
      >
    </form>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { validationMixin } from "vuelidate";
import {
  required,
  minLength,
  maxLength,
  email
} from "vuelidate/lib/validators";

export default {
  name: "FormValidation",
  mixins: [validationMixin],
  data: () => ({
    form: {
      nama: null,
      nik: null,
      jk: null,
      prodi_id: null,
      email: null
    },
    userSaved: false,
    sending: false
  }),
  validations: {
    dosenData: {
      nama: {
        required
      },
      nik: {
        required
      },
      jk: {
        required
      },
      prodi_id: {
        required
      },
      email: {
        required,
        email
      }
    }
  },
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("dosen", ["dosenData"]),
    ...mapState("prodi", ["prodiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.header})`
      };
    }
  },
  methods: {
    ...mapActions("dosen", ["createDosen"]),
    ...mapActions("prodi", ["getProdiList"]),
    async onFetchData() {
      await this.getProdiList();
    },
    async onSubmit() {
      this.$v.$touch();
      this.sending = true;
      if (!this.$v.invalid) {
        try {
          await this.createDosen({
            id: this.$route.params.id,
            payload: this.dosenData
          });
          this.sending = false;
          this.dosenData = {};
          this.$router.push({ name: "manajemen-dosen" });
        } catch (error) {
          this.sending = false;
          throw Error(error);
        }
      }
    },
    getValidationClass(fieldName) {
      const field = this.$v.dosenData[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    saveUser() {
      this.sending = true;
      window.setTimeout(() => {
        this.userSaved = true;
        this.sending = false;
        this.clearForm();
      }, 1500);
    },
    validateUser() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.saveUser();
      }
    }
  },
  async mounted() {
    await this.onFetchData();
    this.onResponsiveInverted();
    window.addEventListener("resize", this.onResponsiveInverted);
  }
};
</script>

<style lang="scss" scoped></style>

<style lang="css">
.md-progress-bar {
  margin: 24px;
}
</style>
